import java.util.*;
import java.lang.*;
import java.io.*;
public class Eliminator {
    Vector stopw;

    public Eliminator() {
	stopw = new Vector();
	try{
	    FileReader reader = new FileReader("Stop-Words.Text");
	    BufferedReader breader = new BufferedReader(reader);
	    while (breader.ready()) {
		String current = breader.readLine();
		stopw.add(current);
	    }
	}
	catch(FileNotFoundException e) {
	    System.out.println("file not found");
	}
	catch(IOException e) {
	    System.out.println("could not read file");
	}
    }

    public Eliminator(String file) {
	stopw = new Vector();
	try{
	    FileReader reader = new FileReader(file);
	    BufferedReader breader = new BufferedReader(reader);
	    while (breader.ready()) {
		String current = breader.readLine();
		stopw.add(current);
	    }
	}
	catch(FileNotFoundException e) {
	    System.out.println("file not found");
	}
	catch(IOException e) {
	    System.out.println("could not read file");
	}
    }

    public ArrayList eliminate(ArrayList words) {
	ArrayList capital = new ArrayList();
	for (int i = 0; i < words.size(); i++) {
	    String curr = (String)words.get(i);
	    capital.add(curr.toUpperCase());
	}
	ArrayList cfil = new ArrayList();
	for (int i = 0; i <capital.size(); i ++) {
	    String curr = (String)capital.get(i);
	    if (!(stopw.contains(curr))) {
		cfil.add(curr);
	    }
	}
	ArrayList lfil = new ArrayList();
	for (int i = 0; i < cfil.size(); i++) {
	    String curr = (String)cfil.get(i);
	    lfil.add(curr.toLowerCase());
	}

    	return lfil;
    }
}
