import java.util.*;
import java.net.*;
import java.io.*;
import javax.swing.text.*; 
import java.lang.*;
import javax.swing.text.html.*;
import javax.swing.text.html.parser.*;

public class GetWords2 {
  
  OMCNet extractor;
  Hashtable table = new Hashtable();
  ArrayList list = new ArrayList();
  ArrayList relationsNames = new ArrayList();
  ArrayList relations = new ArrayList();
   
    public GetWords2() {
	extractor = new OMCNet();
	relationsNames = extractor.getRelations();   
    }

  public ArrayList getSynonyms(String word) {
    ArrayList answer = extractor.getSynonyms(word);
    return answer;
  }
    
    public Hashtable queryAllRelationsOneByOne(ArrayList keywords) {
	ArrayList relns = extractor.getRelations();
	Hashtable answer = new Hashtable();
	int numOfRelations = relns.size();

	for(int i = 0; i<numOfRelations; i++)
	    {
		answer.put(relns.get(i), queryRelation(keywords, (String) relns.get(i)));
	    }
	
	return answer;
    }    


  public ArrayList filter(ArrayList lis) {
    Eliminator eli = new Eliminator();
    int x = lis.size();
    String str;
    String[] strArray;
    ArrayList temp = new ArrayList();
    ArrayList answer = new ArrayList();
    int length=0;
    
    for (int i=0 ; i<x ; i++) 
      {
	str = (String) lis.get(i);
	strArray = str.split(" ", 0);
	length = strArray.length;
	for(int j=0; j<length; j++)
	  {
	    temp.add(strArray[j]);
	  }
      }
    //System.out.println(temp);
    //answer = temp;
    answer = combine(answer, eli.eliminate(temp));
    //return answer;
    
    ArrayList answer2 = new ArrayList();
    
    for(int y = 0; y < answer.size(); y++) 
      {
	if (!answer2.contains(answer.get(y)))
	  answer2.add(answer.get(y));
      }
    return answer2;
  }


  public ArrayList translate(ArrayList input, String from, String to, int x) {
    Translator tr = new Translator();
    tr.setLang(to);
    tr.setFromLang(from);
    int startFrom = 20*x;
    int length = input.size();
    ArrayList answer = new ArrayList();
    String str = "";
    int z=0;
    int w = Math.min(length, startFrom+20);
    int r = w - startFrom;

    if(startFrom < length)
      {
	String trWord = "";
	String[] strArray;
	for(int i=startFrom; i<w ; i++)
	  {
	    trWord = tr.translate((String) input.get(i));
	    strArray = trWord.split("_ ", 0);
	    answer.add(strArray[0]);


	    /*	    if(z==0)
	      {
		str = str + (String) input.get(i);
		z = 1;
	      }
	    else
	      {
		str = str + " - " + (String) input.get(i);
	      }
	  }
	
	System.out.println("This is your translation input");
	System.out.println(str);
	String ans = tr.translate(str);
	System.out.println("This is your translation output");
	System.out.println(ans);
	String[] strArray;
	String[] strArray2;
	strArray = ans.split(" - ", 0);
	
	int l = strArray.length;
	if(l==r)
	  {
	    System.out.println("Length is 20");
	    for(int j=0; j<l; j++) 
	      {
		System.out.println(strArray[j]);
	      }
	    
	    //	int l = strArray.length;
	    for(int j=0; j<l; j++)
	      {
		answer.add(strArray[j]);
	      }
	  }
	else
	  {
	    System.out.println("Length is NOT 20");
	    for(int j=0; j<l; j++) 
	      {
		System.out.println(strArray[j]);
	      }
	    
	    strArray = ans.split(" -", 0);
	    int ccc =0;
	    String ttt = "";
	    l = strArray.length;
	    for(int j=0; j<l; j++)
	      {
		ccc = 20*x + j;
		ttt = (String) strArray[j];
		ttt = ttt.trim();
		System.out.println("."+ttt+"."); 
		if(ttt.equals(""))
		  answer.add(tr.translate((String) input.get(ccc)));
		else
		  {
		    answer.add(ttt);
		  }
	      }
	
	    */
	  }
      }
      	
    //	System.out.println(answer);
	return answer;
  }

  
  public ArrayList translatedList(ArrayList input, int x) {
    int startFrom = 20*x;
    int length = input.size();
    ArrayList answer = new ArrayList();
    int w = Math.min(length, startFrom+20);
    
    if(startFrom < length)
      {
	for(int i=startFrom; i<w ; i++)
	  {
		answer.add(input.get(i));
	  }
      }
    return answer;
  }
  
  
  public ArrayList queryRelation(ArrayList keywords, String relation) {
    int numOfKeywords = keywords.size();
    ArrayList ls = new ArrayList();
    ArrayList l1;
    ArrayList l2;
    ArrayList allOutput = new ArrayList();
    ArrayList allOutput2 = new ArrayList();
    ArrayList answer = new ArrayList();
    ArrayList answerWord = new ArrayList();
    ArrayList answerScore = new ArrayList();
    ArrayList answerScore2 = new ArrayList();

    //FINDING THE QUERIES RESULTS:
    //----------------------------
    for (int j=0; j<numOfKeywords; j++) {
      l1 = extractor.getWordsWithSource((String) keywords.get(j), relation);
      l2 = extractor.getWordsWithTarget((String) keywords.get(j), relation);
      l1 = combine(l1, l2);
      allOutput = combine(allOutput, l1);  //build a collection for
                                           //all the outputs that
					   //come up
      for(int u=0; u<l1.size(); u++) {
      allOutput2.add(new Integer(j));
      }

      ls.add(l1);             //add to the list of lists of output
    }

     
    //FINDING THE STATISTICS:
    //-----------------------
    ArrayList kwoutput;
    int sizeOfOutput = allOutput.size();
    Integer integ;
    Integer integ007;
    ArrayList list007;
    int z=0;
    int t=0;
    int d=0;

    for (int j=0; j<numOfKeywords; j++) {  
      kwoutput = (ArrayList) ls.get(j);  //outpout for one keyword
				         //for all relations
	
      z = kwoutput.size();
      for (int k=0; k < z; k++) {
	  if(!answerWord.contains(kwoutput.get(k)))
	      {
		  answerWord.add(kwoutput.get(k));
		  answerScore.add(new Integer(1));
		  answerScore2.add(new ArrayList());
	                        //create 3 lists
		                //with output for
   		            	//one keyword for
		                //this relation.
	      }
	}
	
      for (int m=0; m<sizeOfOutput; m++) {     //go through the
						 //output and find the
						 //statistics of the
						 //occurance of each
						 //output word/phrase
	if(answerWord.contains(allOutput.get(m)))
	  {
	    t = answerWord.indexOf(allOutput.get(m));
	    integ = (Integer) answerScore.get(t);
	    d = integ.intValue();
	    d++;
	    answerScore.set(t, new Integer(d));
	    
	    integ007 = (Integer) allOutput2.get(m);
	    list007 = (ArrayList) answerScore2.get(t);
	    if(!contains(list007, integ007))
	      list007.add(integ007);
	    answerScore2.set(t, list007);
	  }
      }
    }

    
    ArrayList perKeywordScore= new ArrayList();
    ArrayList tt = new ArrayList();
    for(int y=0; y<answerScore2.size(); y++)
      {
	tt = (ArrayList) answerScore2.get(y);
	perKeywordScore.add(new Integer(tt.size()));
      }

    ArrayList answer2 = new ArrayList();

    if((answerWord != null) && (answerWord.size() != 0)) {
    //System.out.println("Accross queries score");
    //System.out.println(answerScore);
    answer = insertSort(answerWord, answerScore);
        
    ArrayList rr = new ArrayList();
    rr = insertSort(perKeywordScore, answerScore);
    //System.out.println("Per query score");
    //System.out.println(perKeywordScore);
    //System.out.println(rr);

    //System.out.println(answer);


    answer2 = insertSort(answer, rr);
    }
    
    if((answer2 != null) && (answer2.size() != 0)) {
      ArrayList answer3 = filter(answer2);
      return answer3;
    }
    return answer2; 
  }



  public ArrayList queryRelationWithSource(ArrayList keywords, String relation) {
    int numOfKeywords = keywords.size();
    ArrayList ls = new ArrayList();
    ArrayList l1;
    ArrayList l2;
    ArrayList allOutput = new ArrayList();
    ArrayList allOutput2 = new ArrayList();
    ArrayList answer = new ArrayList();
    ArrayList answerWord = new ArrayList();
    ArrayList answerScore = new ArrayList();
    ArrayList answerScore2 = new ArrayList();

    //FINDING THE QUERIES RESULTS:
    //----------------------------
    for (int j=0; j<numOfKeywords; j++) {
      l1 = extractor.getWordsWithSource((String) keywords.get(j), relation);
      allOutput = combine(allOutput, l1);  //build a collection for
                                           //all the outputs that
					   //come up
      for(int u=0; u<l1.size(); u++) {
      allOutput2.add(new Integer(j));
      }

      ls.add(l1);             //add to the list of lists of output
    }

     
    //FINDING THE STATISTICS:
    //-----------------------
    ArrayList kwoutput;
    int sizeOfOutput = allOutput.size();
    Integer integ;
    Integer integ007;
    ArrayList list007;
    int z=0;
    int t=0;
    int d=0;

    for (int j=0; j<numOfKeywords; j++) {  
      kwoutput = (ArrayList) ls.get(j);  //outpout for one keyword
				         //for all relations
	
      z = kwoutput.size();
      for (int k=0; k < z; k++) {
	  if(!answerWord.contains(kwoutput.get(k)))
	      {
		  answerWord.add(kwoutput.get(k));
		  answerScore.add(new Integer(1));
		  answerScore2.add(new ArrayList());
	                        //create 3 lists
		                //with output for
   		            	//one keyword for
		                //this relation.
	      }
	}
	
      for (int m=0; m<sizeOfOutput; m++) {     //go through the
						 //output and find the
						 //statistics of the
						 //occurance of each
						 //output word/phrase
	if(answerWord.contains(allOutput.get(m)))
	  {
	    t = answerWord.indexOf(allOutput.get(m));
	    integ = (Integer) answerScore.get(t);
	    d = integ.intValue();
	    d++;
	    answerScore.set(t, new Integer(d));
	    
	    integ007 = (Integer) allOutput2.get(m);
	    list007 = (ArrayList) answerScore2.get(t);
	    if(!contains(list007, integ007))
	      list007.add(integ007);
	    answerScore2.set(t, list007);
	  }
      }
    }
    
    ArrayList perKeywordScore= new ArrayList();
    ArrayList tt = new ArrayList();
    for(int y=0; y<answerScore2.size(); y++)
      {
	tt = (ArrayList) answerScore2.get(y);
	perKeywordScore.add(new Integer(tt.size()));
      }

    ArrayList answer2 = new ArrayList();
    if((answerWord != null) && (answerWord.size() != 0)) {
    //System.out.println("Accross queries score");
    //System.out.println(answerScore);
    answer = insertSort(answerWord, answerScore);
        
    ArrayList rr = new ArrayList();
    rr = insertSort(perKeywordScore, answerScore);
    //System.out.println("Per query score");
    //System.out.println(perKeywordScore);
    //System.out.println(rr);

    //System.out.println(answer);

    answer2 = insertSort(answer, rr);
    }

    if((answer2 != null) && (answer2.size() != 0)) {
      ArrayList answer3 = filter(answer2);
      return answer3;
    }
    return answer2;

  }






  public ArrayList queryRelationWithTarget(ArrayList keywords, String relation) {
    int numOfKeywords = keywords.size();
    ArrayList ls = new ArrayList();
    ArrayList l1;
    ArrayList l2;
    ArrayList allOutput = new ArrayList();
    ArrayList allOutput2 = new ArrayList();
    ArrayList answer = new ArrayList();
    ArrayList answerWord = new ArrayList();
    ArrayList answerScore = new ArrayList();
    ArrayList answerScore2 = new ArrayList();

    //FINDING THE QUERIES RESULTS:
    //----------------------------
    for (int j=0; j<numOfKeywords; j++) {
      l1 = extractor.getWordsWithTarget((String) keywords.get(j), relation);
      allOutput = combine(allOutput, l1);  //build a collection for
                                           //all the outputs that
					   //come up
      for(int u=0; u<l1.size(); u++) {
      allOutput2.add(new Integer(j));
      }

      ls.add(l1);             //add to the list of lists of output
    }

     
    //FINDING THE STATISTICS:
    //-----------------------
    ArrayList kwoutput;
    int sizeOfOutput = allOutput.size();
    Integer integ;
    Integer integ007;
    ArrayList list007;
    int z=0;
    int t=0;
    int d=0;

    for (int j=0; j<numOfKeywords; j++) {  
      kwoutput = (ArrayList) ls.get(j);  //outpout for one keyword
				         //for all relations
	
      z = kwoutput.size();
      for (int k=0; k < z; k++) {
	  if(!answerWord.contains(kwoutput.get(k)))
	      {
		  answerWord.add(kwoutput.get(k));
		  answerScore.add(new Integer(1));
		  answerScore2.add(new ArrayList());
	                        //create 3 lists
		                //with output for
   		            	//one keyword for
		                //this relation.
	      }
	}
	
      for (int m=0; m<sizeOfOutput; m++) {     //go through the
						 //output and find the
						 //statistics of the
						 //occurance of each
						 //output word/phrase
	if(answerWord.contains(allOutput.get(m)))
	  {
	    t = answerWord.indexOf(allOutput.get(m));
	    integ = (Integer) answerScore.get(t);
	    d = integ.intValue();
	    d++;
	    answerScore.set(t, new Integer(d));
	    
	    integ007 = (Integer) allOutput2.get(m);
	    list007 = (ArrayList) answerScore2.get(t);
	    if(!contains(list007, integ007))
	      list007.add(integ007);
	    answerScore2.set(t, list007);
	  }
      }
    }
    
    ArrayList perKeywordScore= new ArrayList();
    ArrayList tt = new ArrayList();
    for(int y=0; y<answerScore2.size(); y++)
      {
	tt = (ArrayList) answerScore2.get(y);
	perKeywordScore.add(new Integer(tt.size()));
      }

    ArrayList answer2 = new ArrayList();
    if((answerWord != null) && (answerWord.size() != 0)) {
    //System.out.println("Accross queries score");
    //System.out.println(answerScore);
    answer = insertSort(answerWord, answerScore);
        
    ArrayList rr = new ArrayList();
    rr = insertSort(perKeywordScore, answerScore);
    //System.out.println("Per query score");
    //System.out.println(perKeywordScore);
    //System.out.println(rr);

    //System.out.println(answer);

 
    answer2 = insertSort(answer, rr);
    }
   
    if((answer2 != null) && (answer2.size() != 0)) {
      ArrayList answer3 = filter(answer2);
      return answer3;
    }
    return answer2;

  }



    public ArrayList queryAllRelations(ArrayList keywords) {
    int numOfKeywords = keywords.size();
    ArrayList ls = new ArrayList();
    ArrayList l1;
    ArrayList l2;
    ArrayList allOutput = new ArrayList();
    ArrayList allOutput2 = new ArrayList();
    ArrayList answer = new ArrayList();
    ArrayList answerWord = new ArrayList();
    ArrayList answerScore = new ArrayList();
    ArrayList answerScore2 = new ArrayList();

    //FINDING THE QUERIES RESULTS:
    //----------------------------
    for (int j=0; j<numOfKeywords; j++) {
      l1 = extractor.getWordsWithSource((String) keywords.get(j));
      l2 = extractor.getWordsWithTarget((String) keywords.get(j));
      l1 = combine(l1, l2);
      allOutput = combine(allOutput, l1);  //build a collection for
                                           //all the outputs that
					   //come up
      for(int u=0; u<l1.size(); u++) {
      allOutput2.add(new Integer(j));
      }

      ls.add(l1);             //add to the list of lists of output
    }

     
    //FINDING THE STATISTICS:
    //-----------------------
    ArrayList kwoutput;
    int sizeOfOutput = allOutput.size();
    Integer integ;
    Integer integ007;
    ArrayList list007;
    int z=0;
    int t=0;
    int d=0;

    for (int j=0; j<numOfKeywords; j++) {  
      kwoutput = (ArrayList) ls.get(j);  //outpout for one keyword
				         //for all relations
	
      z = kwoutput.size();
      for (int k=0; k < z; k++) {
	  if(!answerWord.contains(kwoutput.get(k)))
	      {
		  answerWord.add(kwoutput.get(k));
		  answerScore.add(new Integer(1));
		  answerScore2.add(new ArrayList());
	                        //create 3 lists
		                //with output for
   		            	//one keyword for
		                //this relation.
	      }
	}
	
      for (int m=0; m<sizeOfOutput; m++) {     //go through the
						 //output and find the
						 //statistics of the
						 //occurance of each
						 //output word/phrase
	if(answerWord.contains(allOutput.get(m)))
	  {
	    t = answerWord.indexOf(allOutput.get(m));
	    integ = (Integer) answerScore.get(t);
	    d = integ.intValue();
	    d++;
	    answerScore.set(t, new Integer(d));
	    
	    integ007 = (Integer) allOutput2.get(m);
	    list007 = (ArrayList) answerScore2.get(t);
	    if(!contains(list007, integ007))
	      list007.add(integ007);
	    answerScore2.set(t, list007);
	  }
      }
    }
    
    ArrayList perKeywordScore= new ArrayList();
    ArrayList tt = new ArrayList();
    for(int y=0; y<answerScore2.size(); y++)
      {
	tt = (ArrayList) answerScore2.get(y);
	perKeywordScore.add(new Integer(tt.size()));
      }


    ArrayList answer2 = new ArrayList();
    if((answerWord != null) && (answerWord.size() != 0)) {
    //System.out.println("Accross queries score");
    //System.out.println(answerScore);
    answer = insertSort(answerWord, answerScore);
        
    ArrayList rr = new ArrayList();
    rr = insertSort(perKeywordScore, answerScore);
    //System.out.println("Per query score");
    //System.out.println(perKeywordScore);
    //System.out.println(rr);

    //System.out.println(answer);

    answer2 = insertSort(answer, rr);
    }

    if((answer2 != null) && (answer2.size() != 0)) {
      ArrayList answer3 = filter(answer2);
      ArrayList answer4 = combine(keywords, answer3);
      return answer4;
    }
    ArrayList answer5 = combine(keywords, answer2);
    return answer5;
  }





  private boolean contains(ArrayList l, Integer i) {
    int j = l.size();
    Integer test;
    for (int m=0; m<j; m++) { 
      test = (Integer) l.get(m);
      if(test.intValue() == i.intValue())
	return true;
    }
    return false;
  }



  public ArrayList queryWithSysnonymsAllRelations(ArrayList keywords) {
    
    ArrayList newKeywords = new ArrayList();
    ArrayList temp;
    int numOfKeywords = keywords.size();
    for(int i=0; i<numOfKeywords; i++) 
      {
	temp = extractor.getSynonyms((String) keywords.get(i));
	newKeywords = combine(newKeywords, temp);
      }
    
    newKeywords = combine(newKeywords, keywords);
    
    ArrayList answer = new ArrayList();
    answer = queryAllRelations(newKeywords);
    return answer;
  }


  public ArrayList queryWithSysnonymsAllRelationsOneByOne(ArrayList keywords) {
    
    ArrayList newKeywords = new ArrayList();
    ArrayList temp;
    int numOfKeywords = keywords.size();
    for(int i=0; i<numOfKeywords; i++) 
      {
	temp = extractor.getSynonyms((String) keywords.get(i));
	newKeywords = combine(newKeywords, temp);
      }
    
    newKeywords = combine(newKeywords, keywords);
    
    ArrayList answer = new ArrayList();
    Hashtable t = queryAllRelationsOneByOne(newKeywords);
    answer.add(t);
    answer.add(newKeywords);
    return answer;
  }
  

       private static ArrayList insertSort(ArrayList words, ArrayList scores) {
	ArrayList answer = new ArrayList();
	ArrayList tempScore = new ArrayList();
	int length = words.size();
	if(length == scores.size())
	    {
		if(length >= 0)
		    {
			answer.add(words.get(0));
			tempScore.add(scores.get(0));
		    }
		
		int i;
		int key;
		int a_i;
		Integer integ;
		Integer integ2;
		Integer integ3;
		
		if(length > 0)
		    {
			for(int j = 1; j<length; j++)
			    {
				integ = (Integer) scores.get(j);
				key = integ.intValue();
				
				for(int k=j-1; k>=0; k--)
				    {
					integ2 = (Integer) tempScore.get(k);
					if(integ2.intValue() < key)
					    {
						answer.add(k+1, words.get(j));
						tempScore.add(k+1, scores.get(j));
						break;
					    }
					else if (k==0)
					    {answer.add(k, words.get(j));
					    tempScore.add(k, scores.get(j));}
				    }
			    }
			
		    }
	    }

	int zz=answer.size();
	ArrayList reverseSort = new ArrayList();
	for(int dd=1; dd<=zz; dd++)
	  {
	    reverseSort.add(answer.get(zz-dd));
	  }
	//System.out.println(tempScore);
	return reverseSort;
 }

    
  public ArrayList combine(ArrayList l1, ArrayList l2) {
    int x = l2.size();
    int y = l1.size();

    ArrayList l3 = new ArrayList();
    for (int j=0; j<y; j++) {
      l3.add(l1.get(j));
    }

    for (int i=0; i<x; i++) {
      l3.add(l2.get(i));
    } 

    return l3;
  }



    public ArrayList queryAllRelationsGiveMeRelevantToAll(ArrayList keywords) {
    int numOfKeywords = keywords.size();
    ArrayList ls = new ArrayList();
    ArrayList l1;
    ArrayList l2;
    ArrayList allOutput = new ArrayList();
    ArrayList allOutput2 = new ArrayList();
    ArrayList answer = new ArrayList();
    ArrayList answerWord = new ArrayList();
    ArrayList answerScore = new ArrayList();
    ArrayList answerScore2 = new ArrayList();

    //FINDING THE QUERIES RESULTS:
    //----------------------------
    for (int j=0; j<numOfKeywords; j++) {
      l1 = extractor.getWordsWithSource((String) keywords.get(j));
      l2 = extractor.getWordsWithTarget((String) keywords.get(j));
      l1 = combine(l1, l2);
      allOutput = combine(allOutput, l1);  //build a collection for
                                           //all the outputs that
					   //come up
      for(int u=0; u<l1.size(); u++) {
      allOutput2.add(new Integer(j));
      }

      ls.add(l1);             //add to the list of lists of output
    }

     
    //FINDING THE STATISTICS:
    //-----------------------
    ArrayList kwoutput;
    int sizeOfOutput = allOutput.size();
    Integer integ;
    Integer integ007;
    ArrayList list007;
    int z=0;
    int t=0;
    int d=0;

    for (int j=0; j<numOfKeywords; j++) {  
      kwoutput = (ArrayList) ls.get(j);  //outpout for one keyword
				         //for all relations
	
      z = kwoutput.size();
      for (int k=0; k < z; k++) {
	  if(!answerWord.contains(kwoutput.get(k)))
	      {
		  answerWord.add(kwoutput.get(k));
		  answerScore.add(new Integer(1));
		  answerScore2.add(new ArrayList());
	                        //create 3 lists
		                //with output for
   		            	//one keyword for
		                //this relation.
	      }
	}
	
      for (int m=0; m<sizeOfOutput; m++) {     //go through the
						 //output and find the
						 //statistics of the
						 //occurance of each
						 //output word/phrase
	if(answerWord.contains(allOutput.get(m)))
	  {
	    t = answerWord.indexOf(allOutput.get(m));
	    integ = (Integer) answerScore.get(t);
	    d = integ.intValue();
	    d++;
	    answerScore.set(t, new Integer(d));
	    
	    integ007 = (Integer) allOutput2.get(m);
	    list007 = (ArrayList) answerScore2.get(t);
	    if(!contains(list007, integ007))
	      list007.add(integ007);
	    answerScore2.set(t, list007);
	  }
      }
    }    

    ArrayList perKeywordScore= new ArrayList();
    ArrayList tt = new ArrayList();
    for(int y=0; y<answerScore2.size(); y++)
      {
	tt = (ArrayList) answerScore2.get(y);
	perKeywordScore.add(new Integer(tt.size()));
      }

    ArrayList answer2 = new ArrayList();
    Integer anInt = new Integer(0);
    for(int yy=0; yy<perKeywordScore.size(); yy++)
      {
	anInt = (Integer) perKeywordScore.get(yy);
	if(anInt.intValue() == keywords.size())
	  answer2.add(answerWord.get(yy));
      }

    return answer2;
    }





  
}
