import java.io.*;
import java.util.*;

class MyMap implements Serializable
{
  private BufferedReader inputFile;
  private HashMap WordMap = new HashMap();
  private String[] WordFiles = {"foodWrd.txt" , "accomodationWrd.txt", "travelWrd.txt" ,
				  "leisureWrd.txt" , "storeWrd.txt" , "serviceWrd.txt" ,
				"health.txt" , "emergency.txt"};

  public String[] names = {"Food & Dining" , "Accomodations" ,  "Travel & Transportation" , "Leisure" , "Shopping" , "Services" , "Health & Safety" , "Emergency"};
    
    public MyMap() {
	makeWordMap();
    }

  public String[] getNames() {
    return names;
  }

    public void addWordEntry(WordEntry entry)
    {
      Word w = (Word) entry.getWord();
      WordMap.put((String) w.toString(), entry);
    }
  
    public WordEntry getWordEntry(String key)
	{
	    return (WordEntry)WordMap.get(key);
	}
    
    public Category getCategory(String key)
    {
	return getWordEntry(key).getCategory();
    }
    public HashMap makeWordMap()
    {
	int i = 0;
	int filenbr = WordFiles.length;
	//int[] mycategory = {0,0,0,0,0,0,0,0};
	String myword;
	do {
	  //mycategory[i] = 1;
	    try{
		File inputFile = new File(WordFiles[i]);
		FileReader in = new FileReader(inputFile);
		BufferedReader br = new BufferedReader(in);
		String line = br.readLine();		
		

		
		while (line != null)
		    {
			//System.out.println(line);			
			//  WordEntry myentry = 
		      
		      int[] mycategory = {0,0,0,0,0,0,0,0};
		      mycategory[i] = 1;
		      
			myword = line;
			Word wordTest = new Word(myword);
			WordEntry entry = getWordEntry(myword);
			if (entry == null)
			    {
				
				WordEntry myentry = new WordEntry(wordTest,
								  new Category(mycategory));
				
				addWordEntry(myentry);
			    }
			else {
			    entry.getCategory().modify(i,1);
			    
			}
			
			line = br.readLine();
		    }
		
		in.close();
	    }
	    catch(IOException e)
		{System.out.println("File not found.");}
	    
	    i = i+1;
	}
	while(i<filenbr);
	
	return WordMap;
    }


  public boolean contains(String str) {
    if (WordMap.get(str) == null)
      return false;
    return true;
  }

    
}
