import java.util.*;
import java.net.*;
import java.io.*;
import javax.swing.text.*; 
import java.lang.*;
import javax.swing.text.html.*;
import javax.swing.text.html.parser.*;

public class PhotoSelector {

    private ArrayList fileNames = new ArrayList();
    private ArrayList wordList = new ArrayList();
    private ArrayList l1 = new ArrayList();
    private String def = "smile.s.gif";

    private void prepare() {
    fileNames.add("smile.s.gif");
    l1.add("smile"); 
    l1.add("smiling");
    l1.add("smily"); 
    l1.add("happy");
    l1.add("glad");
    wordList.add(l1);

    fileNames.add("think.s.gif");
    l1 = new ArrayList();
    l1.add("think");
    l1.add("thought");
    l1.add("thinking");
    l1.add("math"); 
    l1.add("mathematics"); 
    l1.add("formula"); 
    l1.add("formulas"); 
    l1.add("problem"); 
    l1.add("solving"); 
    l1.add("solve"); 
    wordList.add(l1);

    fileNames.add("telephone.s.gif");
    l1 = new ArrayList();
    l1.add("telephone"); 
    l1.add("call"); 
    l1.add("phone"); 
    l1.add("phone-call"); 
    l1.add("ring"); 
    l1.add("ringing"); 
    l1.add("rang");
    l1.add("dial"); 
    l1.add("dialing"); 
    l1.add("dialed"); 
    l1.add("talk"); 
    l1.add("talking"); 
    l1.add("talked");
    wordList.add(l1);

    
    fileNames.add("smoke.s.gif");
    l1 = new ArrayList();
    l1.add("smoke"); 
    l1.add("smoking"); 
    l1.add("cigarette"); 
    l1.add("tobacco"); 
    l1.add("cigar"); 
    l1.add("lighter");
    wordList.add(l1);
    
    fileNames.add("sing.s.gif");
    l1 = new ArrayList();
    l1.add("sing"); 
    l1.add("singing"); 
    l1.add("sang"); 
    l1.add("song"); 
    l1.add("microphone"); 
    l1.add("concert");
    l1.add("singer");    
    wordList.add(l1);
    
    fileNames.add("shop.s.gif");
    l1 = new ArrayList();
    l1.add("shop");   
    l1.add("shopping");   
    l1.add("shopped");   
    l1.add("buy");   
    l1.add("buying");   
    l1.add("bought");   
    l1.add("sale");   
    l1.add("discount");  
    l1.add("store");  
    l1.add("clothes");  
    wordList.add(l1);

    fileNames.add("readnewspaper.s.gif");
    l1 = new ArrayList();
    l1.add("news");   
    l1.add("newspaper");   
    l1.add("article");   
    l1.add("paper");  
    l1.add("journal");  
    wordList.add(l1);
    
    fileNames.add("playpiano.s.gif");
    l1 = new ArrayList();
    l1.add("music"); 
    l1.add("concert"); 
    l1.add("piano");
    wordList.add(l1);
    
    fileNames.add("marry.s.gif");
    l1 = new ArrayList();
    l1.add("wedding");  
    l1.add("marriage");  
    l1.add("husband");  
    l1.add("wife");  
    l1.add("bride");  
    l1.add("groom");  
    l1.add("wedding-dress");         
    wordList.add(l1);
    

    fileNames.add("lose2.s.gif");
    l1 = new ArrayList();
    l1.add("directions"); 
    l1.add("way"); 
    l1.add("lose"); 
    l1.add("lost"); 
    l1.add("map"); 
    l1.add("street"); 
    l1.add("crossing"); 
    l1.add("confused"); 
    l1.add("confusing"); 
    l1.add("confusion");
    wordList.add(l1);


    fileNames.add("lookat.s.gif");
    l1 = new ArrayList();
    l1.add("look");
    l1.add("looking"); 
    l1.add("looked"); 
    l1.add("watch"); 
    l1.add("watching"); 
    l1.add("watched"); 
    l1.add("observe"); 
    l1.add("observing"); 
    l1.add("observed");
    wordList.add(l1);
    

    fileNames.add("laugh.s.gif");
    l1 = new ArrayList();
    l1.add("laugh"); 
    l1.add("laughing"); 
    l1.add("laughed"); 
    l1.add("laughter");     
    wordList.add(l1);
    
    fileNames.add("introduce.s.gif");
    l1 = new ArrayList();
    l1.add("introduce");  
    l1.add("introducing");  
    l1.add("introduced");  
    l1.add("present");  
    l1.add("presenting");  
    l1.add("presented");  
    l1.add("meet");  
    l1.add("met");  
    l1.add("meeting"); 
    wordList.add(l1);


    fileNames.add("headache.s.gif");
    l1 = new ArrayList();
    l1.add("pain"); 
    l1.add("headache"); 
    l1.add("aspirin"); 
    l1.add("ache"); 
    l1.add("painful"); 
    l1.add("paracetamol");   
    wordList.add(l1);
    
    
    fileNames.add("fight.s.gif");
    l1 = new ArrayList();
    l1.add("fight");    
    l1.add("fighting");    
    l1.add("fought");    
    l1.add("hit");    
    l1.add("hitting");    
    l1.add("punched");    
    l1.add("pucnhing");    
    l1.add("slapping");    
    l1.add("slapped");    
    l1.add("slap");    
    l1.add("quarrel");    
    l1.add("quarelling");    
    l1.add("quarelled");   
    wordList.add(l1);


    fileNames.add("fever.s.gif");
    l1 = new ArrayList();
    l1.add("sick"); 
    l1.add("fever"); 
    l1.add("ill"); 
    l1.add("sickness"); 
    l1.add("illness"); 
    l1.add("medication"); 
    l1.add("pill"); 
    l1.add("prescription");
    l1.add("medicine");
    wordList.add(l1);


    fileNames.add("drink.s.gif");
    l1 = new ArrayList();
    l1.add("drink"); 
    l1.add("drinking"); 
    l1.add("drank"); 
    l1.add("thirsty"); 
    l1.add("water"); 
    l1.add("cup"); 
    l1.add("glass");
    l1.add("sip"); 
    l1.add("sipping"); 
    l1.add("sipped");
    l1.add("milk");
    wordList.add(l1);


    fileNames.add("eat1.s.gif");
    l1 = new ArrayList();
    l1.add("eat"); 
    l1.add("food"); 
    l1.add("restaurant"); 
    l1.add("fork"); 
    l1.add("plate"); 
    l1.add("knife");
    wordList.add(l1);


    fileNames.add("dance.s.gif");
    l1 = new ArrayList();
    l1.add("dance"); 
    l1.add("danced"); 
    l1.add("dancing"); 
    l1.add("party"); 
    l1.add("club"); 
    l1.add("clubbing"); 
    l1.add("night-club"); 
    l1.add("disco"); 
    l1.add("music"); 
    l1.add("dj");    
    wordList.add(l1);


    fileNames.add("cook.s.gif");
    l1 = new ArrayList();
    l1.add("cook");  
    l1.add("cooked");  
    l1.add("cooking");  
    l1.add("food");  
    l1.add("kitchen");  
    l1.add("kitchenette");
    l1.add("pot");  
    l1.add("pots");  
    l1.add("oven");  
    l1.add("stove"); 
    l1.add("baking"); 
    l1.add("bake"); 
    l1.add("baked"); 
    l1.add("stir"); 
    l1.add("fry"); 
    l1.add("stirring"); 
    l1.add("frying"); 
    l1.add("fried"); 
    wordList.add(l1);


    fileNames.add("clean.s.gif");
    l1 = new ArrayList();
    l1.add("clean");  
    l1.add("cleaning");  
    l1.add("cleaned");  
    l1.add("room");  
    l1.add("roomservice");  
    l1.add("room-service");  
    l1.add("service");  
    l1.add("tidy");     
    l1.add("maid"); 
    wordList.add(l1);


    fileNames.add("ask.s.gif");
    l1 = new ArrayList();
    l1.add("ask");  
    l1.add("asking");  
    l1.add("asked");  
    l1.add("question"); 
    l1.add("help"); 
    wordList.add(l1);

    fileNames.add("getdrunk.s.jpg");
    l1 = new ArrayList();
    l1.add("drink"); 
    l1.add("drinking"); 
    l1.add("drunk"); 
    l1.add("alcohol"); 
    l1.add("beer"); 
    l1.add("bar"); 
    l1.add("intoxicated");
    wordList.add(l1);
    }

    public PhotoSelector() {
	prepare();
    }

    public String getPhoto(ArrayList keywords) {
	String answer = "";
	int[] temp = new int[fileNames.size()];
	for (int i=0; i<fileNames.size(); i++) 
	    {
		temp[i] = compare(keywords, (ArrayList) wordList.get(i));
	    }

	int x = 0;
	for (int j=0; j<fileNames.size(); j++)
	    {
		if(temp[j]>temp[x])
		    x = j;
	    }

	answer = (String) fileNames.get(x);
	return answer;
    }

    private int compare(ArrayList keywords, ArrayList l2) {
	
	int count = 0;
	String word = "";
	String kword = "";
	for(int i=0; i<l2.size(); i++)
	    {
		for(int j=0; j<keywords.size(); j++)
		    {
			word = (String) l2.get(i);
			kword = (String) keywords.get(j);
			if(word.equals(kword))
			    count++;
		    }
	    }
	return count;
    }

    
}
