import java.io.*;


class WordEntry implements  Serializable

{

    private Word word;
    private Category category;

    public WordEntry(Word word, Category category)
    {
	this.word = word;
	this.category = category;
    }

    public Word getWord()
    {
	return word;
    }

    public Category getCategory()
    {
	return category;
    }

    public String toString()
    {
	return word.toString() + '\n' + category.toString();
    }

    //Read an entry from file
    //filename is just the name of the file without the .txt extension
    /*
    public static WordEntry readEntry(String filename)
    {
  	
	return new Wordentry(aWord,aCategory);
    }
    */


}
